#install.packages("devtools")
#install.packages("foreach")
#install.packages("RSpectra")
library(RSpectra)
library(foreach)
library(devtools)
#devtools::install_github("bcm-uga/lfmm")
library(lfmm)

setwd("~")

Y <- read.table(file = "./genoFile.env", header = F)
X <- read.table(file = "./envFile.env", header = F)

numLatFac <- 1

###### Ridge estimates #####

## Fit and LFMM, i.e, compute B, U, V estimates
mod.lfmm <- lfmm_ridge(Y = Y, 
                       X = X, 
                       K = numLatFac)
## performs association testing using the fitted model:
pv <- lfmm_test(Y = Y, 
                X = X, 
                lfmm = mod.lfmm, 
                calibrate = "gif")

###### Lasso estimates #####

## Fit an LFMM, i.e, compute B, U, V estimates
mod.lfmm <- lfmm_lasso(Y = Y, 
                       X = X, 
                       K = numLatFac,
                       nozero.prop = 0.01) # error: Error in tcrossprod(crossprod(x, U), V) : non-conformable arguments

## performs association testing using the fitted model:
pv <- lfmm_test(Y = Y, 
                X = X, 
                lfmm = mod.lfmm, 
                calibrate = "gif")